# coding: utf-8
'''
Created on 18.12.2013

@author: v.popov
'''
import json
from java.text import SimpleDateFormat
import uuid

try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO

try:
    from ru.curs.showcase.core.jython import JythonDownloadResult
except:
    pass

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from common.sysfunctions import toHexForXml

from flute._flute_orm import tasksCursor
from nci.functions.persons import getPersonIdBySid


def gridData(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, sortColumnList=None, firstrecord=None, pagesize=None):
    u'''Функция получения данных для грида. '''

    sid = json.loads(session)['sessioncontext']['sid']
    personid = getPersonIdBySid(context, sid)
    # Создание экземпляра курсора eokCursor
    xlreports = tasksCursor(context)
    #xlreports.setFilter('script', "@%'report'%")
    xlreports.setRange('user', personid)
    xlreports.orderBy('id desc')
    
    script_name = {'edu.reports.specialityReport.printToFlute': u'Отчёт по реализации возможности обучения по специальностям с использованием образовательного сертификата',
                   'edu.reports.specialityReport.printConsolidateToFlute': u'Сводный отчёт по реализации возможности обучения по специальностям с использованием образовательного сертификата',
                   'edu.reports.programReport.printToFlute': u'Отчёт по формированию организациями, осуществляющими образовательную деятельность, реестра образовательных программ подготовки медицинских работников  с применением',
                   'edu.reports.programReport.printConsolidateToFlute': u'Сводный отчёт по формированию организациями, осуществляющими образовательную деятельность, реестра образовательных программ подготовки медицинских работников  с применением',
                   'edu.reports.studentReport.printToFlute': u'Справка по обучению  специалистов по образовательным сертификатам организацией, осуществляющей образовательную деятельность',
                   
                   }

    # Определяем переменную для JSON данных
    data = {"records":{"rec":[]}}
    dateformat = SimpleDateFormat("dd.MM.yyyy HH:mm")
    df = SimpleDateFormat("dd.MM.yyyy")
    # Проходим по таблице и заполняем data
    for rec in xlreports.iterate():
        rec_dict = {}
        # Заносим uid в ~~id
        rec_dict[toHexForXml('~~id')] = rec.id
        # Заносим name в Название ЭКО
        rec_dict["ID"] = rec.id
        if rec.script in script_name:
            rec_dict["Название"] = script_name[rec.script]
        else:
            rec_dict["Название"] = rec.script

        # параметры отчета разложенные в строку, должны быть ключи на русском
        if rec.parameters is not None:
            params = json.loads(rec.parameters)
            params_text = ''
            for k in params:
                if params_text != '':
                    params_text = u'%s, %s' % (params_text, u'%s: %s' % (k, params[k]))
                else:
                    params_text = u'%s: %s' % (k, params[k])
            rec_dict["Параметры"] = params_text
        else:
            rec_dict["Параметры"] = ''

        if rec.datecreated is not None:
            rec_dict["Время"] = dateformat.format(rec.datecreated) if rec.datecreated is not None else ''
        else:
            rec_dict["Время"] = ''

        # Заносим событие в properties
        rec_dict['properties'] = {"event":
                    {"@name":"row_single_click",
                     "action": {
                        '#sorted': [
                            {"main_context": 'current'},
                            {"datapanel": {
                                '@type':"current",
                                '@tab':"current"}}]}}}


        data["records"]["rec"].append(rec_dict)


    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(data)), None)


def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Функция получения настроек грида. '''

    sid = json.loads(session)['sessioncontext']['sid']
    personid = getPersonIdBySid(context, sid)
    # Создание экземпляра курсора eokCursor
    xlreports = tasksCursor(context)
    
    xlreports.setRange('user', personid)

    totalcount = xlreports.count()
    # Заголовок таблицы
    header = ""
    # В случае если таблица пустая
    if totalcount == 0 or totalcount is None:
        totalcount = "0"


    dpheight = json.loads(session)['sessioncontext']['currentDatapanelHeight']

    # Определяем список полей таблицы для отображения
    settings = {}
    settings["gridsettings"] = {"columns": {"col":[]},
            "properties": {"@pagesize":"50",
                            "@gridWidth": "100%", #"%dpx" % (int(dpwidth) - 50) if dpwidth not in ('0', '', 0) else "800px",
                            "@gridHeight":int(int(dpheight) * 0.8),
                             "@totalCount": totalcount,
                              "@profile":"default.properties"},
                                "labels":{"header":header}
                                }
    # Добавляем поля для отображения в gridsettings
    settings["gridsettings"]["columns"]["col"].append({"@id":"ID", "@width": "20px"})
    settings["gridsettings"]["columns"]["col"].append({"@id":"Название"})
    settings["gridsettings"]["columns"]["col"].append({"@id":"Параметры"})
    settings["gridsettings"]["columns"]["col"].append({"@id":"Время", "@width": "50px"})

    return JythonDTO(None, XMLJSONConverter.jsonToXml(json.dumps(settings)))


def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Toolbar для грида. '''

    sessionjson = json.loads(session)
    download_style = "true"
    request_id = ''
    if "gridContext" in sessionjson["sessioncontext"]["related"] \
    and 'currentRecordId' in sessionjson["sessioncontext"]["related"]["gridContext"]:
        download_style = "false"
        xlreports = tasksCursor(context)
        xlreports.get(sessionjson["sessioncontext"]["related"]["gridContext"]['currentRecordId'])
        request_id = xlreports.request_id

    data = {"gridtoolbar":
                {"#sorted":
                    [
                     {"item":
                        {"@text":u"Построить отчет",
    #                    "@img":"bad.png",
                         "@hint":u"Построить отчет",
                         "@disable":"false",
                         "action":
                             {"@show_in":"MODAL_WINDOW",
                              "#sorted":
                                [{"main_context":'current'},
                                 {"modalwindow":
                                    {"@caption":"Построить отчет",
                                     "@height":"400",
                                     "@width":"700"
                                     }
                                  },
                                 {"datapanel":
                                    {"@type":"current",
                                     "@tab":"current",
                                     "element":
                                         {"@id":'addReportCard',
                                          "add_context": ""}
                                    }
                                 }]
                             }
                         }
                      },
                        {"item":
                         {"@text":u"Скачать",
    #                    "@img":"bad.png",
                         "@hint":u"Скачать",
                         "@disable":download_style,
                         "action":
                             {"@show_in":"MODAL_WINDOW",
                              "#sorted":
                                [{"main_context":'current'},
                                 {"modalwindow":
                                    {"@caption":"Скачать",
                                     "@height":"200",
                                     "@width":"250"
                                     }
                                  },
                                 {"datapanel":
                                    {"@type":"current",
                                     "@tab":"current",
                                     "element":
                                         {"@id":'downloadReportCard',
                                          "add_context": request_id}
                                    }
                                 }]
                             }

                         }

                          }]
                     }
                 }

    return XMLJSONConverter.jsonToXml(json.dumps(data))

