# coding: utf-8

from java.util import ArrayList

from edu._edu_orm import vw_courseCursor
from nci._nci_orm import person_edu_organizationCursor
from security.functions import userHasPermission
from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid


try:
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    pass


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None,
                     params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для vw_courseCursor'''

    vw_course = vw_courseCursor(context)
    vw_course.orderBy('name')
    vw_course.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    vw_course.limit(firstRecord, recordCount)

    count = vw_course.count()

    recordList = ArrayList()
    for row in vw_course.iterate():
        record = DataRecord()
        record.id = str(row.uid)
        record.name = u'%s (%d часов) - %s' % (row.name, row.course_hours, row.edu_organization_name)
        recordList.add(record)

    return ResultSelectorData(recordList, count)


def courseList(context, main=None, add=None, filterinfo=None, session=None,
               params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для vw_courseCursor'''
    sid = JsonPath.read(session, "$.sessioncontext.sid")
    course = vw_courseCursor(context)
    course.orderBy('name')
    course.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    course.limit(firstRecord, recordCount)

    if not userHasPermission(context, sid, "allEduOrgCourse"):
        person_org = person_edu_organizationCursor(context)
        person_org.setRange("person_id", getPersonIdBySid(context, sid))
        if not person_org.count():
            context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
        edu_list = []
        for person_org in person_org.iterate():
            edu_list.append("'%s'" % person_org.edu_organization_id)
        course.setFilter("edu_organization_id", "|".join(edu_list))

    recordList = ArrayList()
    for course in course.iterate():
        record = DataRecord()
        record.id = str(course.uid)
        record.name = u'%s (%d часов) - %s' % (course.name,
                                                   course.course_hours,
                                                   course.edu_organization_name)
        recordList.add(record)

    return ResultSelectorData(recordList, 0)


def courseCount(context, main=None, add=None, filterinfo=None, session=None,
                params=None, curValue=None, startsWith=None):
    '''ListAndCount для vw_courseCursor'''
    sid = JsonPath.read(session, "$.sessioncontext.sid")
    course = vw_courseCursor(context)
    course.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    if not userHasPermission(context, sid, "allEduOrgCourse"):
        person_org = person_edu_organizationCursor(context)
        person_org.setRange("person_id", getPersonIdBySid(context, sid))
        if not person_org.count():
            context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
        edu_list = []
        for person_org in person_org.iterate():
            edu_list.append("'%s'" % person_org.edu_organization_id)
        course.setFilter("edu_organization_id", "|".join(edu_list))

    count = course.count()

    return ResultSelectorData(None, count)
