# coding: utf-8
'''
Created on 04.08.2014
Карточка ФЛ
@author: v.popov
'''
import json
import uuid
from medstaff._medstaff_orm import student_programCursor
try:
    from org.apache.commons.lang3.StringEscapeUtils import unescapeHtml4
except:
    pass
from com.jayway.jsonpath import JsonPath
from edu._edu_orm import vw_courseCursor, courseCursor, course_cycleCursor, course_edu_formCursor,\
course_edu_baseCursor, course_contingentCursor

from nci._nci_orm import person_edu_organizationCursor, edu_organizationCursor, education_formCursor,\
education_baseCursor

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor
from security.functions import userHasPermission
from nci.functions.persons import getPersonIdBySid
import cgi


try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка КДПП'''
    ss = json.loads(session)['sessioncontext']    
#     sid = JsonPath.read(session, "$.sessioncontext.sid")
    sid = ss["sid"]
    u"""Курсор для таблицы программ"""
    vw_course = vw_courseCursor(context)
    u"""Курсор для таблицы специальностей"""
    speciality = specialityCursor(context)
    edu_org = edu_organizationCursor(context)
    u"""Курсор для составной таблицы программ и форм обучения"""
    course_edu_form = course_edu_formCursor(context)
    u"""Курсор для составной таблицы программ и основ обучения"""
    course_edu_base = course_edu_baseCursor(context)
    u"""Курсор таблицы форм обучения"""
    edu_formCurs = education_formCursor(context)
    u"""Курсор таблицы основ обучения"""
    edu_baseCurs = education_baseCursor(context)
    u"""Курсор таблицы программ и контингента"""
    course_contingent = course_contingentCursor(context)
    
    u"""Форма обучения, основа обучения и контингент.
    Далее в переменные будут записаны словари, содержащие
    информацию о формах и основах обучения, а также о специальностях.
    Полученные данные будут отображены в картоке редактирования"""
    forms = ""
    bases = ""
    contingent = ""
    
    if not userHasPermission(context, sid, "allEduOrgCourse"):
        u"""Если пользователь вошел как методист,
        присвоить программе статус 'На проверке'"""
        status_id = 0
        person_org = person_edu_organizationCursor(context)
        person_org.setRange("person_id", getPersonIdBySid(context, sid))
        if not person_org.count() and add in ["add", 'edit']:
            context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
        edu_list = []
        for person_org in person_org.iterate():
            edu_list.append("'%s'" % person_org.edu_organization_id)
            edu_org.setFilter("uid", "|".join(edu_list))
            edu_org.findSet()
    else:
        u"""Если пользователь вошел под sid образовательной организации,
        присвоить программе статус 'Формируется'"""
        status_id = 8
        
    record_id = None
    if add in ['edit','info','infoCard']:
#         record_id = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
        try:
            record_id = ss["related"]["gridContext"]["currentRecordId"]
        except:
            record_id = main
            
        try:
            main_jsn = json.loads(main)            
        except:
            main_jsn = None
        
        if main_jsn:
            record_id = main_jsn['courseId']
        
        vw_course.setRange('uid', record_id)
        vw_course.findSet()
        speciality.tryGet(vw_course.speciality_id)
        status_id = vw_course.status_id
        u"""Поиск записей в составной таблице программ и форм обучения 
        (для заполнения мультиселектора).
        Отбор форм обучения для заданной программы"""
        course_edu_form.setRange("course_id",record_id)
        if course_edu_form.count() > 0:
            preforms = []
            u"""Поиск названий форм обучения по id"""
            for form in course_edu_form.iterate():
                id = form.edu_form_id
                edu_formCurs.get(id)
                edu_form_name = edu_formCurs.name
                preforms.append({"@id": id,
                              "@name": edu_form_name})
            forms = {"form": preforms}
            
            
        u"""Поиск записей в составной таблице программ и основ обучения 
        (для заполнения мультиселектора).
        Отбор основ обучения для заданной программы"""
        course_edu_base.setRange("course_id",record_id)
        if course_edu_base.count() > 0:
            prebases = []
            u"""Поиск названий форм обучения по id"""
            for base in course_edu_base.iterate():
                id = base.edu_base_id
                edu_baseCurs.get(id)
                edu_base_name = edu_baseCurs.name
                prebases.append({"@id": id,
                              "@name": edu_base_name})
            bases = {"base": prebases}
            
        u"""Поиск записей в составной таблице программ и контингента
        (для заполнения мультиселектора).
        Отбор форм обучения для заданной программы"""
        course_contingent.setRange("course_id",record_id)
        if course_contingent.count() > 0:
            precontingent = []
            u"""Поиск названий специальностей контингента по id"""
            for contingent in course_contingent.iterate():
                id = contingent.speciality_id
                speciality.get(id)
                speciality_name = speciality.name
                precontingent.append({"@id": id,
                              "@name": speciality_name})
            contingent = {"speciality": precontingent}       
    
    xformsdata = {
        "schema": {
            "@xmlns": "",
            "record": {
                "uid": vw_course.uid,
                "name": vw_course.name,
                "isCertification": "true" if vw_course.isCertification else "false",
                "str_unit":vw_course.str_unit,
                "speciality_id": speciality.uid,
                "speciality_name": speciality.name,
                "contingent": contingent,
                "dev_year": int(vw_course.dev_year) if vw_course.dev_year else '',
                "hours": int(vw_course.course_hours) if vw_course.course_hours else '',
                "edu_type": u"ПК",
                "edu_organization_id":  vw_course.edu_organization_id or edu_org.uid,
                "edu_organization_name": vw_course.edu_organization_name or edu_org.shortname,
                "all_edu_org": userHasPermission(context, sid, "allEduOrgCourse"),
                "program_link": vw_course.program_link,
                "edu_forms": forms,
                "edu_cost": vw_course.edu_cost if vw_course.edu_cost else '0',
                "cost_explanation": vw_course.cost_explanation,
                "edu_bases": bases,
                "osk": "true" if vw_course.osk else "false",
                "osk_hours": int(vw_course.osk_hours) if vw_course.osk_hours else '',
                "osk_description": vw_course.osk_description,
                "internship": "true" if vw_course.internship else "false",
                "internship_hours": int(vw_course.internship_hours) if vw_course.internship_hours else '',
                "internship_description": vw_course.internship_description,
                "dot_and_eo": "true" if  vw_course.dot_and_eo else "false",
                "dot_and_eo_description": vw_course.dot_and_eo_description,
                "relevance": vw_course.relevance,
                "new_competence_reception": "true" if vw_course.new_competence_reception else "false",
                "new_competence_description": vw_course.new_competence_description,
                "note": unescapeHtml4(vw_course.note) if vw_course.note else '',
                "addcontext": add,
                "status_id": int(status_id),
                "error_flag": "false"
                
            }
        }
    }
     
    xformssettings = {
            "properties": {
                    "event": [{
                            "@name": "single_click",
                            "@linkId": "1",
                            "action": {
                                "@keep_user_settings": "true",
                                '#sorted': [
                                    {"main_context": "current"},
                                    {"datapanel": {
                                        "@type": "current",
                                        "@tab": "current",
                                        "element": [
                                                        {
                                                            "@id": "courseGrid"                                                            
                                                        }
                                                    ]
                                              }}]
                                       }          
                               }]
                           }
                      }
    
    if add == "add":
        xformssettings["properties"]["event"][0]["action"]['#sorted'][1]["datapanel"]["element"].append({
                                                            "@id": "courseCycleGrid",
                                                            "add_context": "hide"
                                                        })
    
    if add == "edit":
        xformssettings["properties"]["event"][0]["action"]['#sorted'][1]["datapanel"]["element"].append(
                                                                        {"@id": "courseCycleGrid",
                                                                        "add_context": ""
                                                                        })
        
                          
    xformssettings["properties"]["event"].append({
                                            "@name": "single_click",
                                            "@linkId": "2",
                                            "action": {
                                                "@keep_user_settings": "true",
                                                '#sorted': [
                                                    {"main_context": "current"},
                                                    {"datapanel": {
                                                        "@type": "current",
                                                        "@tab": "current",
                                                        "element": [
                                                            {"@id": elementId,
                                                             "add_context": "hide"}]}}]}})
    
    xformssettings["properties"]["event"].append({
                                            "@name": "single_click",
                                            "@linkId": "3",
                                            "action": {
                                                '#sorted': [
                                                {'main_context': 'current'},
                                                {'navigator': {
                                                    '@element': 'courses',
                                                    '@refresh': 'true'}},
                                                {'server' : {
                                                    'activity' : {
                                                        '@id': "addOpenedCource", 
                                                        '@name': "edu.server.serverAction.closeOpenedCource.celesta",
                                                        'add_context': record_id}}}]}})

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение данных о КДПП. '''
    
    if add != 'info':
        u"""Курсор для таблицы программ"""
        course = courseCursor(context)
        u"""Курсор для таблицы форм обучения"""
        edu_form = education_formCursor(context)
        u"""Курсор для таблицы основ обучения"""
        edu_base = education_baseCursor(context)
        u"""Курсор для таблицы программ и форм обучения"""
        course_edu_form = course_edu_formCursor(context)
        u"""Курсор для таблицы программ и основ обучения"""
        course_edu_base = course_edu_baseCursor(context)
        u"""Курсор для таблицы программ и контингента"""
        course_contingent = course_contingentCursor(context)
        u"""Курсор для таблицы специальностей"""
        speciality = specialityCursor(context)
        u"""Курсор для таблицы циклов"""
        course_cycle = course_cycleCursor(context)
        
        u"""uid - уникальный идентификатор."""
        uid = ""
        
        data_dict = json.loads(xformsdata)["schema"]["record"]
        if add == 'add':
            u"""Генерация уникального ключа."""
            uid= unicode(uuid.uuid4())
            course.uid = uid
        else:
            # Редактирование уже существующей
            uid = data_dict["uid"]
            course.get(uid)
            
        course.name = data_dict["name"]
        course.isCertification = True if data_dict["isCertification"] == "true" else False
        course.dev_year = data_dict["dev_year"]
        course.hours = data_dict["hours"]
        course.edu_type = u'ПК'
        course.speciality_id = data_dict["speciality_id"]
        course.edu_organization_id = data_dict["edu_organization_id"]
        course.program_link = data_dict["program_link"]
        course.edu_cost = data_dict["edu_cost"]
        course.cost_explanation = data_dict["cost_explanation"]
        course.str_unit = data_dict["str_unit"]
        course.osk = True if data_dict["osk"] == "true" else False
        course.osk_hours = data_dict['osk_hours'] if data_dict['osk_hours'] and course.osk else  None
        course.osk_description = data_dict["osk_description"] if course.osk else ''
        course.internship = True if data_dict["internship"] == "true" else False
        course.internship_hours = data_dict["internship_hours"] if data_dict["internship_hours"] and course.internship else None
        course.internship_description = data_dict["internship_description"] if course.internship else ''
        course.dot_and_eo = True if data_dict["dot_and_eo"] == "true" else False
        course.dot_and_eo_description = data_dict["dot_and_eo_description"] if course.dot_and_eo else ''
        course.relevance = data_dict["relevance"]
        course.new_competence_reception = True if data_dict["new_competence_reception"] == "true" else False
        course.new_competence_description = data_dict["new_competence_description"] if course.new_competence_reception else ''
        course.note = data_dict["note"]
        course.status_id = data_dict["status_id"]
        
        u"""Установка правильных значений для поля ДОТ и ЭО и его описания
        в таблице циклов"""
        course_cycle.setRange("course_id",course.uid)
        if course_cycle.count() > 0:
            course_cycle.tryFirst()
            course_cycle.dot_and_eo = True if data_dict["dot_and_eo"] == "true" else False
            course_cycle.dot_and_eo_description = data_dict["dot_and_eo_description"] if data_dict["dot_and_eo"] == "true" else ''
            course_cycle.update()
            
        u"""Получение списка форм обучения по данной программе"""
        if "form" in data_dict["edu_forms"]:
            data_form_store = data_dict["edu_forms"]["form"]
        else:
            data_form_store = None
        u"""Получение списка основ обучения по данной программе"""
        if "base" in data_dict["edu_bases"]:
            data_base_store = data_dict["edu_bases"]["base"]
        else:
            data_base_store = None
        u"""Получение списка контингента по данной программе"""
        if "speciality" in data_dict["contingent"]:
            data_contingent_store = data_dict["contingent"]["speciality"]
        else:
            data_contingent_store = None
            
        u"""Обработка случая одиночного выбора в мультиселекторе"""
        if not isinstance(data_form_store, list) and data_form_store:
            data_form_store = [data_form_store]
        if not isinstance(data_base_store, list) and data_base_store:
            data_base_store = [data_base_store]
        if not isinstance(data_contingent_store, list) and data_contingent_store:
            data_contingent_store = [data_contingent_store]
            
        if add == 'add' :
            course.insert()
        else:
            course.update()
            u"""Отбор форм обучения для заданной программы"""
            course_edu_form.setRange("course_id", uid)
            u"""Отбор основ обучения для заданной программы"""
            course_edu_base.setRange("course_id", uid)
            u"""Отбор специальностей для контингента заданной программы"""
            course_contingent.setRange("course_id",uid)
            
            u"""Удаление найденных записей"""
            course_edu_form.deleteAll()
            course_edu_base.deleteAll()
            course_contingent.deleteAll()
            
            u"""Обновление записей(вставка)"""
        if data_form_store:
            eduFormInsert(course_edu_form,data_form_store,uid)
        if data_base_store:   
            eduBaseInsert(course_edu_base,data_base_store,uid)
        if data_contingent_store:   
            contingentInsert(course_contingent,data_contingent_store,uid)

                    


def eduFormInsert(course_edu_form,data_form_store,uid):
    u"""Добавление записей в составную таблицу программ и форм обучения"""
    for form in data_form_store:
        course_edu_form.course_id = uid
        course_edu_form.edu_form_id = form['@id']
        course_edu_form.insert()

def eduBaseInsert(course_edu_base,data_base_store,uid):
    u"""Добавление записей в составную таблицу программ и основ обучения"""
    for base in data_base_store:
        course_edu_base.course_id = uid
        course_edu_base.edu_base_id = base['@id']
        course_edu_base.insert()

def contingentInsert(course_contingent,data_contingent_store,uid):
    u"""Добавление записей(специальностей)
     в составную таблицу программ и контингента"""
    for speciality in data_contingent_store:
        course_contingent.course_id = uid
        course_contingent.speciality_id = speciality['@id']
        course_contingent.insert()


def deleteCardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''
    course_cycle = course_cycleCursor(context)
    curr_rec = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
    course_cycle.setRange("course_id", curr_rec)
    u"""Разрешение/запрет удаления"""
    enable_delete = "true" # удаление возможно
    
    u"""Проверка наличия циклов по заданной программе"""
    if course_cycle.count():
        form_text = u"Программа содержит неутвержденные циклы! \
        Вы действительно хотите удалить программу и её циклы?"

        u"""Id статуса со значением'утвержден'"""
        acceptedStatusId = 3
        u"""Поиск циклов со статусом 'утвержден'"""
        course_cycle.setRange("status_id", acceptedStatusId)
        
        u"""При наличии циклов со статусом 'утвержден', удаление программы невозможно!"""
        if course_cycle.count():
            form_text = u"Программа содержит утвержденные циклы! Удаление невозможно!"
            enable_delete = "false"
    else:
        form_text = u"Вы действительно хотите удалить программу?!"
    
    xforms_data = {
        'schema': {
            '@xmlns': '',
            'data': {
                'form_text': form_text,
                'enable_delete': enable_delete
            }
        }
    }

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                    'action': {
                        '@keep_user_settings': "false",
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': [{
                                  '@id': 'courseGrid'
                              },
                                {'@id': 'courseCycleGrid',
                                  'add_context': 'hide'},
                                {'@id': 'courseCycleFilter',
                                 'add_context':'hide'}]
                          }}]
                    }
                },
                {
                    '@name': 'single_click',
                    '@linkId': '2',
                    'action': {
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': {
                                  '@id': elementId,
                                  'add_context': 'hide'
                              }
                          }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def deleteCardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''
    session = json.loads(session)
    data = json.loads(xformsdata)["schema"]["data"]
    
    u"""Получение выделенной программы"""
    course_id = session['sessioncontext']['related']['gridContext']['currentRecordId']
    
    studentProgramCur = student_programCursor(context)
    studentProgramCur.setRange("course_id", course_id)
    if studentProgramCur.tryFirst():
        context.error(u'По данной программе уже проходят обучение.')
    
    course = courseCursor(context)
    course_cycle = course_cycleCursor(context)
    course_edu_form = course_edu_formCursor(context)
    course_edu_base = course_edu_baseCursor(context)
    

    course.get(course_id)
    
    u"""Поиск и удаление циклов выбранной программы"""
    course_cycle.setRange("course_id", course_id)
    if course_cycle.count() and data["enable_delete"] == "true":
        course_cycle.deleteAll()
        
    u"""Удаление програмы"""
    course.delete()
    
    u"""Поиск записей о формах и основах обучения по заданной программе"""
    course_edu_form.setRange("course_id", course_id)
    course_edu_base.setRange("course_id", course_id)
    u"""Удаление"""
    course_edu_form.deleteAll()
    course_edu_base.deleteAll()
    
def html2Edit(context, main, add, filterinfo, session, elementId):
    jsonData = json.loads(filterinfo)
    html = jsonData['schema']['filter']['note']

    data = html.replace('&lt;', '<').replace('&gt;', '>').replace('&lt', '<').replace('&gt', '>').replace('&nbsp;', ' ').replace('&nbsp', ' ')
    try:
        minidom.parseString(data)
    except:
        data = "<div>%s</div>" % data
    settings = u'''<properties></properties>'''
    res = JythonDTO(data, settings)
    return res
