# coding: utf-8

from java.text import SimpleDateFormat
import json

from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci._nci_orm import status_listCursor
from security.functions import userHasPermission
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO



def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка цикла аккредитации'''
    if context.getData().get(elementId,''):
        xformsdata = context.getData()[elementId]
    else:
        u"""Курсор для таблицы статусов"""
        statusCursor = status_listCursor(context)
        
        sid = JsonPath.read(session, "$.sessioncontext.sid")
        # определяем идентификатор ФЛ по sid
        person_id = getPersonIdBySid(context, sid)
        df = SimpleDateFormat("dd.MM.yyyy")
    
        bool_values = [{"label":u'Да',
                        "value":'true'},
                       {"label":u'Нет',
                        "value":'false'},
                       {"label":u'Все',
                        'value':'-'}]
        
        if not userHasPermission(context, sid, "allEduOrgCourse"):
            hasPermission = False
        else:
            hasPermission = True
        
        u"""Список статусов"""
        status_values = [ {"label":u'Все', "value":'-'} ]
        
        u"""Заполнение списка статусов/ статус 'На проверке' не нужен"""
        for status in statusCursor.iterate():
            if not hasPermission:
                if status.id != 2:
                    status_values.append({"label": status.name,
                                          "value": status.id
                                          })
            else:
                if status.id != 2 and status.id != 0:
                    status_values.append({"label": status.name,
                                          "value": status.id
                                          })
            
        xformsdata = {"schema":
                          {"@xmlns": "",
                           "record":
                                {
                               'toDate':'',
                               'fromDate':'',
                               'bool_values':bool_values,
                               'status_values': status_values,
                               'status': '-',
                               'outside': '-',
                               'status': '-',
                                "@filter":'0'
                                }
                            }
                          }



    xformssettings = {"properties":{
                                    "event":[{"@name":"single_click",
                                              "@linkId": "1",
                                              "action":{
                                                '#sorted': [
                                                    {"main_context": "current"},
                                                    {"datapanel": {"@type": "current",
                                                                      "@tab": "current",
                                                                      "element": {"@id":"courseCycleGrid",
                                                                                  "add_context": "current"}
                                                                       }}]
                                                         }
                                              }]
                                    }
                      }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, xformsdata=None):
    context.getData()[elementId] = json.loads(xformsdata)
