# coding: utf-8

import json

from security.functions import userHasPermission
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from edu._edu_orm import course_cycle_qti_packageCursor
from edu.constants import *
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка учебного плана по теме'''        
    xformsdata = {"schema": {
                    "@xmlns": "",
                    "data": {
                        "eorType": TEST,
                        "qtiList": '',
                        'types': {'type': [{'@id': x, '#text': EOR_TYPE[x][0]} for x in EOR_TYPE.keys()]}}}}
  
    xformssettings = {'properties': {
        'event': [
            {'@name': 'single_click',
             '@linkId': '1',
             'action': {
                '@keep_user_settings': 'false',
                '#sorted': [
                    {'main_context': 'current'},
                    {'datapanel': {
                        '@type': 'current',
                        '@tab': 'current',
                        'element': {
                            '@id': 'courseCycleQtiPackageGrid',
                            'add_context': ''}}}]}},
            {'@name': 'single_click',
             '@linkId': '2',
             'action': {
                '@keep_user_settings': 'true',
                '#sorted': [
                    {'main_context': 'current'},
                    {'datapanel': {
                        '@type': 'current',
                        '@tab': 'current',
                        'element': {
                            '@id': 'courseCycleQtiPackageGrid',
                            'add_context': ''}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
#     courseCycleId = json.loads(session)['sessioncontext']['related']['gridContext']['currentRecordId']
    cycle_id = main
    eorData = json.loads(xformsdata)['schema']['data']
    eorType = int(eorData['eorType'])
    qtiList = eorData['qtiList']['qti']
    if not isinstance(qtiList, list):
        qtiList = [qtiList]
  
    cycleQtiCur = course_cycle_qti_packageCursor(context)
    
    order = 0
    if add:
        if cycleQtiCur.tryGet(cycle_id, add):
            order = cycleQtiCur.qti_order - 1            
            index = len(qtiList)
            cycleQtiCur.setRange('course_cycle_id', cycle_id)
            cycleQtiCur.setFilter('qti_order', '>{}'.format(order))
            for c in cycleQtiCur.iterate():
                c.qti_order += index
                c.update()
            
    else:
        cycleQtiCur.setRange('course_cycle_id', cycle_id)
        cycleQtiCur.orderBy('qti_order DESC')
        if cycleQtiCur.tryFirst():
            order = cycleQtiCur.qti_order
            
    cycleQtiCur.clear()    
    for qti in qtiList:
        qti_id = qti['@id']
        if not cycleQtiCur.tryGet(cycle_id, qti_id):
            order += 1
            cycleQtiCur.course_cycle_id = cycle_id
            cycleQtiCur.qti_package_id = qti_id
            cycleQtiCur.eor_type = eorType
            cycleQtiCur.qti_order = order
            cycleQtiCur.insert()
    cycleQtiCur.close()
    
    
def deleteCardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''
    # Структура данных
    xforms_data = {'schema': {
                    '@xmlns': '',
                    'data': {
                        'form_text': 'Вы действительно хотите удалить выделенные записи?'}}}

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {'@name': 'single_click',
                 '@linkId': '1',
                 'action': {
                    '@keep_user_settings': 'false',
                    '#sorted': [
                        {'main_context': 'current'},
                        {'datapanel': {
                            '@type': 'current',
                            '@tab': 'current',
                            'element': {
                                '@id': 'courseCycleQtiPackageGrid',
                                'add_context': ''}}}]}},
                {'@name': 'single_click',
                 '@linkId': '2',
                 'action': {
                    '@keep_user_settings': 'true',
                    '#sorted': [
                        {'main_context': 'current'},
                        {'datapanel': {
                            '@type': 'current',
                            '@tab': 'current',
                            'element': {
                                '@id': 'courseCycleQtiPackageGrid',
                                'add_context': ''}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def deleteCardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''    
    cycle_id = main
    try:
        qtiRows = json.loads(session)['sessioncontext']['related']['gridContext']["selectedRecordId"]
        if not isinstance(qtiRows, list):
            qtiRows = [qtiRows]
    except:
        qtiRows = None
            
            
    if cycle_id and qtiRows:
        qtiPackageCur = course_cycle_qti_packageCursor(context)
        for qtiItem in qtiRows:
            if qtiPackageCur.tryGet(cycle_id, qtiItem):
                qtiPackageCur.delete()  
                
        qtiPackageCur.clear()
        qtiPackageCur.setRange('course_cycle_id', cycle_id)
        order = 0
        qtiPackageCur.orderBy('qti_order')
        for qti in qtiPackageCur.iterate():
            order += 1
            qti.qti_order = order
            qti.update()         


def qtiControlTypeChangeData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''
#     raise Exception(json.dumps(add))
    add_jsn = json.loads(add)
    cycle_id = add_jsn['cycle_id']
    qti_id = add_jsn['qti_id']
    control_type = 1    
    
    if cycle_id and qti_id:
        qtiPackageCur = course_cycle_qti_packageCursor(context)
        if qtiPackageCur.tryGet(cycle_id, qti_id):
            control_type = qtiPackageCur.control_type
        qtiPackageCur.close()
    
    # Структура данных
    xforms_data = {'schema': {
                    '@xmlns': '',
                    'data': {
                        'cycle_id': cycle_id,
                        'qti_id': qti_id,
                        'control_type': control_type,
                        'types': {'type': [{'@id': x, '#text': CONTROL_TYPE[x]} for x in CONTROL_TYPE]}}}}

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {'@name': 'single_click',
                 '@linkId': '1',
                 'action': {
                    '@keep_user_settings': 'true',
                    '#sorted': [
                        {'main_context': 'current'},
                        {'datapanel': {
                            '@type': 'current',
                            '@tab': 'current',
                            'element': {
                                '@id': 'courseCycleQtiPackageGrid',
                                'add_context': ''}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def qtiControlTypeChangeSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''    
    add_jsn = json.loads(add)
    
    cycle_id = add_jsn['cycle_id']
    qti_id = add_jsn['qti_id']
            
    if cycle_id and qti_id:
        data = json.loads(xformsdata)['schema']['data']
        qtiPackageCur = course_cycle_qti_packageCursor(context)
        if qtiPackageCur.tryGet(cycle_id, qti_id):
            qtiPackageCur.control_type = data['control_type']
            qtiPackageCur.update()   
        qtiPackageCur.close()
            