# coding: utf-8

import json
import uuid

from nci._nci_orm import education_levelCursor, speciality_commissionsCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO

def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''

    spec_id = json.loads(add)['speciality_id']
    
    speciality_commission = speciality_commissionsCursor(context)
    speciality_commission.setRange("speciality_id", spec_id)
    
    xforms_data = {
            'schema': {
                '@xmlns': '',
                'certTemplate': {'row':{'memberFio':'', 'memberPosition':'', 'chairman': 'False'}},
                'data': {'specId':spec_id,
                'cert': {'row':[{'memberFio':'', 'memberPosition':'', 'chairman': 'True'},
                {'memberFio':'', 'memberPosition':'', 'chairman': 'False'},]},
                'gia': {'memberFio':'', 'memberPosition':'', 'chairman': 'False'}},
                
            }
        }
    certRows = []
    rowGia = None
    for row in speciality_commission.iterate():
        if (row.report_type == 'giaReport'):
            rowGia = {'memberFio':row.member_fio, 'memberPosition':row.member_position, 'chairman': row.chairman}
        else:
            certRows.append({'memberFio':row.member_fio, 'memberPosition':row.member_position, 'chairman': row.chairman})
    if (rowGia == None):
        rowGia = {'memberFio':'', 'memberPosition':'', 'chairman': ''}
    if (len(certRows) == 0):
        certRows = [{'memberFio':'', 'memberPosition':'', 'chairman': 'True'},
        {'memberFio':'', 'memberPosition':'', 'chairman': 'False'},]
    xforms_data['schema']['data']['gia'] = rowGia
    xforms_data['schema']['data']['cert']['row'] = certRows
    

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                    'action': {
                        '@keep_user_settings': 'true',
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': {
                                  '@id': 'specCommissionGrid',
                                  'add_context': ''
                              }
                          }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    specialities = specialityCursor(context)
#     education_level = education_levelCursor(context)

    speciality_commission = speciality_commissionsCursor(context)
    data_dict = json.loads(xformsdata)['schema']['data']

    giaMemberFio = data_dict['gia']['memberFio']
    giaMemberPosition = data_dict['gia']['memberPosition']
    certList = data_dict['cert']['row']
    specId = data_dict['specId']
    speciality_commission.setRange('speciality_id', specId);
    speciality_commission.setRange('report_type', 'giaReport');
    speciality_commission.tryFirst();
    speciality_commission.speciality_id = specId
    speciality_commission.member_fio = giaMemberFio
    speciality_commission.member_position = giaMemberPosition
    if (speciality_commission.id == None):
        speciality_commission.report_type = 'giaReport'
        speciality_commission.speciality_id = specId
        speciality_commission.insert()
    else:
        speciality_commission.update()
    speciality_commission.setRange('speciality_id', specId)
    speciality_commission.setRange('report_type', 'certReport')
    speciality_commission.deleteAll()
    speciality_commission.clear()
    hasChairMan = False
    for row in certList:
        speciality_commission.member_fio = row['memberFio']
        speciality_commission.member_position = row['memberPosition']
        speciality_commission.member_position = row['memberPosition']
        chairman = (row['chairman'])
        if (chairman == 'True' or chairman == 'true'):
            chairman = True
        else:
            chairman = False
        if (chairman == True and hasChairMan == False):
            hasChairMan = True
        elif (chairman == True and hasChairMan == True):
            chairman = False
        speciality_commission.chairman = chairman
        speciality_commission.report_type = 'certReport'
        speciality_commission.speciality_id = specId
        speciality_commission.insert()
        speciality_commission.clear()
