# coding: utf-8



from java.util import ArrayList
import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import vw_complex_programCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для vw_complex_programCursor'''

    try:
        spec_id = json.loads(XMLJSONConverter.xmlToJson(params))['schema']['filter']['speciality_id']
    except:
        spec_id = None
    vw_complex_program = vw_complex_programCursor(context)
    vw_complex_program.orderBy('name')
    vw_complex_program.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    if spec_id:
        vw_complex_program.setRange('speciality_id', spec_id)
    vw_complex_program.limit(firstRecord, recordCount)

    count = vw_complex_program.count()

    recordList = ArrayList()
    for row in vw_complex_program.iterate():
        record = DataRecord()
        record.id = str(row.uid)
        record.name = u'%s (%d часов, %s (%s))' % (row.name, row.hours, row.speciality_name, row.education_level_name)
        recordList.add(record)

    return ResultSelectorData(recordList, count)
