# coding: utf-8
'''
Created on 04.08.2014
Карточка ФЛ
@author: v.popov
'''
import json
import uuid

from com.jayway.jsonpath import JsonPath
from common.sysfunctions import tableCursorImport
from nci._nci_orm import education_levelCursor, cprogram_attr_listCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import complex_programCursor, specialityCursor, \
    cprogram_specializationCursor, cprogram_attributeCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка КДПП'''

    complex_program = complex_programCursor(context)
    speciality = specialityCursor(context)
    cprogram_specialization = cprogram_specializationCursor(context)
    education_level = education_levelCursor(context)
    cprogram_attribute = cprogram_attributeCursor(context)
    cprogram_attr_list = cprogram_attr_listCursor(context)
    cprogram_attr_list.orderBy('sort')

    xformsdata = {"schema":
                      {"record":
                            {"uid": ""
                           , "name": ""
                           , "speciality_id": ""
                           , "speciality_name":""
                           , "dev_year": ""
                           , "hours": ""
                           , "need_reload_params": "true"
                           , 'param': []
                           , "specialization": [{'@id': '', '@name': ''}]
                            }
                       , 'forSubmission': ""
                        }
                      }


    if add == 'edit':
        record_id = JsonPath.read(session, "$.sessioncontext.related.gridContext.currentRecordId")
        complex_program.get(record_id)
        xformsdata['schema']['record']['uid'] = complex_program.uid
        xformsdata['schema']['record']['name'] = complex_program.name
        xformsdata['schema']['record']['dev_year'] = complex_program.dev_year
        xformsdata['schema']['record']['hours'] = complex_program.hours
        xformsdata['schema']['record']['speciality_id'] = complex_program.speciality_id
        if speciality.tryGet(complex_program.speciality_id):
            if education_level.tryGet(speciality.education_level):
                xformsdata['schema']['record']['speciality_name'] = u'%s (%s)' % (speciality.name, education_level.name)
            else:
                xformsdata['schema']['record']['speciality_name'] = speciality.name
        # загрузка специализаций
        cprogram_specialization.setRange('complex_program_id', xformsdata['schema']['record']['uid'])
        for cprogram_specialization in cprogram_specialization.iterate():
            xformsdata['schema']['record']['specialization'].append({'@id': cprogram_specialization.uid, '@name': cprogram_specialization.name})
        if len(xformsdata['schema']['record']['specialization']) > 1:
            del xformsdata['schema']['record']['specialization'][0]
        #
        xformsdata['schema']['record']['need_reload_params'] = 'false'
        # загрузка параметров
        for cprogram_attr_list in cprogram_attr_list.iterate():
            # получаем значение параметра из таблицы значений
            cprogram_attribute.setRange('attribute_id', cprogram_attr_list.id)
            cprogram_attribute.setRange('complex_program_id', record_id)
            cprogram_attribute.tryFirst()
            param = dict()
            param['uid'] = cprogram_attribute.uid
            param['param_id'] = cprogram_attr_list.id
            param['name'] = cprogram_attr_list.name
            param['value'] = cprogram_attribute.attribute_value
            param['values'] = ''
            param['value_show'] = ''
            param['required'] = 'true' if cprogram_attr_list.required else 'false'
            # тип значения - json
            try:
                value_type = json.loads(cprogram_attr_list.value_type)
                # string, integer, decimal, boolean, date, datetime, selector, multiselector
                param['value_type'] = value_type
                if value_type['type'] == 'multiselector':
                    param['values'] = cprogram_attribute.attribute_value
                    vals = param['values'].split(",")
                    shows = ''
                    cur = tableCursorImport(value_type['grain'], value_type['table'])(context)
                    param['values'] = []
                    for x in vals:
                        cur.get(x)
                        item_name = getattr(cur, value_type['name_field'])
                        # дополнительные поля - как в селекторе
                        if 'name_add_fields' in value_type:
                            if isinstance(value_type['name_add_fields'], list):
                                for y in value_type['name_add_fields']:
                                    if hasattr(cur, y):
                                        item_name = u'%s - %s' % (item_name, unicode(getattr(cur, y)))
                            elif isinstance(value_type['name_add_fields'], unicode):
                                if hasattr(cur, value_type['name_add_fields']):
                                    item_name = u'%s - %s' % (item_name, unicode(getattr(cur, value_type['name_add_fields'])))
                        param['values'].append({'item': {'@id': x, "@name": item_name}})
                        shows = u'%s,%s' % (shows, item_name) if shows != '' else item_name
                    # строка, которая будет отображаться
                    param['value_show'] = shows
                if value_type['type'] == 'selector':
                    cur = tableCursorImport(value_type['grain'], value_type['table'])(context)
                    if param['value']:
                        cur.get(param['value'])
                        param['value_show'] = getattr(cur, value_type['name_field'])
                    else:
                        param['value_show'] = ''
                if value_type['type'] == 'boolean':
                    if 'true' in value_type and value_type['true'] == param['value']:
                        param['value'] = 'true'
                    elif 'false' in value_type and value_type['false'] == param['value']:
                        param['value'] = 'false'
                if value_type['type'] == 'select1':
                    param['value'] = cprogram_attribute.attribute_value
#                     raise Exception(param)
                    values = param['value_type']['setValues']
                    param['value_type']['setValues'] = {"item":[]}
                    for value_from_set in values:
                        param['value_type']['setValues']['item'].append({"label":values[value_from_set], "value":value_from_set})


            except:
                param['value_type'] = {'type': 'string'}
            xformsdata['schema']['record']['param'].append(param)



    xformssettings = {"properties":{"event":[{"@name":"single_click", "@linkId": "1",
             "action":{"@keep_user_settings": "true",
                      '#sorted': [
                          {"main_context": "current"},
                          {"datapanel": {"@type": "current",
                                     "@tab": "current",
                                     "element": {"@id":"complexProgramGrid",
                                     "add_context": ""
                                                 }
                                     }}]
                       }
                     }]
                    }
                  }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))

def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение данных о КДПП. '''

    complex_program = complex_programCursor(context)
    cprogram_attribute = cprogram_attributeCursor(context)
    cprogram_attr_list = cprogram_attr_listCursor(context)
    cprogram_specialization = cprogram_specializationCursor(context)

    data_dict = json.loads(xformsdata)

    if data_dict["schema"]["record"]["uid"] == '':
        # Добавление новой записи в person
        complex_program.uid = uuid.uuid4()
        complex_program.name = data_dict["schema"]["record"]["name"]
        complex_program.dev_year = data_dict["schema"]["record"]["dev_year"]
        complex_program.hours = data_dict["schema"]["record"]["hours"]
        complex_program.speciality_id = data_dict["schema"]["record"]["speciality_id"]
        complex_program.status_id = 0
        complex_program.insert()
    else:
        # Редактирование уже существующей
        complex_program.get(data_dict["schema"]["record"]["uid"])
        complex_program.name = data_dict["schema"]["record"]["name"]
        complex_program.dev_year = data_dict["schema"]["record"]["dev_year"]
        complex_program.hours = data_dict["schema"]["record"]["hours"]
        complex_program.speciality_id = data_dict["schema"]["record"]["speciality_id"]
        complex_program.update()

    # сохранение специализаций
    if 'specialization' in data_dict["schema"]["record"]:
        specs = data_dict["schema"]["record"]['specialization']
        if isinstance(specs, dict):
            specs = [specs]
        for spec in specs:
            if spec['@id'] == '':
                # добавляем
                if spec['@name']:
                    cprogram_specialization.uid = uuid.uuid4()
                    cprogram_specialization.complex_program_id = complex_program.uid
                    cprogram_specialization.name = spec['@name']
                    cprogram_specialization.insert()
            else:
                # обновляем
                cprogram_specialization.get(spec['@id'])
                cprogram_specialization.name = spec['@name']
                cprogram_specialization.update()
        # удаляем те, которые удалил пользователь
        cprogram_specialization.setRange('complex_program_id', complex_program.uid)
        cprogram_specialization.setFilter('name', "&".join([u"!'%s'" % x['@name'] for x in specs]))
        cprogram_specialization.deleteAll()
    else:
        # удаляем все специализации
        cprogram_specialization.setRange('complex_program_id', complex_program.uid)
        cprogram_specialization.deleteAll()

    # сохраняем атрибуты
    if 'param' in data_dict['schema']['record']:
        # удаляем старые
        cprogram_attribute.setRange('complex_program_id', complex_program.uid)
        cprogram_attribute.deleteAll()

        params = data_dict['schema']['record']['param']
        if isinstance(data_dict['schema']['record']['param'], dict):
            params = [data_dict['schema']['record']['param']]
        # добавляем-обновляем
        for param in params:
            cprogram_attribute.uid = uuid.uuid4()
            cprogram_attribute.complex_program_id = complex_program.uid
            cprogram_attribute.attribute_id = param['param_id']
            # нужно проверить значения в булевом типе
            try:
                cprogram_attr_list.get(int(param['param_id']))
                value_type = json.loads(cprogram_attr_list.value_type)
                # string, integer, decimal, boolean, date, datetime, selector, multiselector
                param['value_type'] = value_type
                if param['value_type']['type'] == 'boolean':
                    if 'true' in param['value_type'] and param['value_type']['true'] != '' and param['value'] == "true":
                        param['value'] = param['value_type']['true']
                    elif 'false' in param['value_type'] and param['value_type']['false'] != '' and param['value'] == "false":
                        param['value'] = param['value_type']['false']
            except:
                pass
            cprogram_attribute.attribute_value = param['value']
            cprogram_attribute.insert()

def cpAttributes(context, main=None, add=None, filterinfo=None, session=None, data=None):
    u'''функция сабмишна, для атрибутов КДПП'''

    cprogram_attr_list = cprogram_attr_listCursor(context)
    cprogram_attr_list.orderBy('sort')

    xformsdata = {'schema':{'record':{'param':[]}}}
#     xformsdata['data']['param'] = []
    for cprogram_attr_list in cprogram_attr_list.iterate():
        param = dict()
        param['uid'] = ''
        param['param_id'] = cprogram_attr_list.id
        param['name'] = cprogram_attr_list.name
        param['value'] = ''
        param['required'] = 'true' if cprogram_attr_list.required else 'false'
        param['value_show'] = ''
        # тип значения - json
        try:
            value_type = json.loads(cprogram_attr_list.value_type)
            # string, integer, decimal, boolean, date, datetime, selector, multiselector
            param['value_type'] = value_type
            if param['value_type']['type'] == 'multiselector':
                param['values'] = ''
            if param['value_type']['type'] == 'boolean':
                param['value'] = 'false'
            if param['value_type']['type'] == 'select1':
                values = param['value_type']['setValues']
                param['value_type']['setValues'] = {"item":[]}
                for value_from_set in values:
                    param['value_type']['setValues']['item'].append({"label":values[value_from_set], "value":value_from_set})
        except:
            param['value_type'] = {'type': 'string'}
        xformsdata['schema']['record']['param'].append(param)
    xformsdata['schema']['record']['need_reload_params'] = 'false'

    result = XMLJSONConverter.jsonToXml(json.dumps(xformsdata))
    # return result.replace('&lt;', '<').replace('&gt;', '>')
    return result

def deleteCardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Данные для карточки.'''

    string_bool = lambda x: x and 'true' or 'false'

    # Структура данных
    xforms_data = {
        'schema': {
            '@xmlns': '',
            'data': {
                'form_text': 'Вы действительно хотите удалить запись о КДПП?'
            }
        }
    }

    # Первоначальная xforms_settings
    xforms_settings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                    'action': {
                        '@keep_user_settings': string_bool(True),
                        '#sorted': [
                          {'main_context': 'current'},
                          {'datapanel': {
                              '@type': 'current',
                              '@tab': 'current',
                              'element': {
                                  '@id': 'complexProgramGrid',
                                  'add_context': ''
                              }
                          }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xforms_data)),
                     XMLJSONConverter.jsonToXml(json.dumps(xforms_settings)))


def deleteCardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    complex_program = complex_programCursor(context)
    current_id = json.loads(session)['sessioncontext']['related']['gridContext']['currentRecordId']
    complex_program.get(current_id)
    complex_program.delete()