# coding: utf-8
'''

@author: a.rudenko

'''
import json

from common.hierarchy import deleteNodeFromHierarchy
from common.sysfunctions import tableCursorImport
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardDelData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):


    sessionjson = json.loads(session)['sessioncontext']
    gridContext = sessionjson['related']['gridContext']
    elementId0 = elementId
    elementId = gridContext['@id']

    xformsdata = {
        'schema': {
            '@xmlns': ''
        }
    }
    xformssettings = {
        'properties': {
            'event': [
                {
                    '@name': 'single_click',
                    '@linkId': '1',
                      'action': {
                      '#sorted': [
                        {'main_context': 'current'},
                        {'datapanel': {
                            # '@keep_user_settings': string_bool(True),
                            '@type': 'current',
                            '@tab': 'current',
                            'element':{
                                '@id': elementId,
                                'add_context': ''
                            }
                        }}]
                    }
                },
                {
                    '@name': 'single_click',
                    '@linkId': '2',
                    'action': {
                      '#sorted': [
                        {'main_context': 'current'},
                        {'datapanel': {
                            '@type': 'current',
                            '@tab': 'current',
                            'element': {
                                '@id' :elementId0,
                                'add_context': 'hide'
                            }
                        }}]
                    }
                }
            ]
        }
    }
    # 2015-05-27 Афонин В.В. - для массового удаления, когда в гриде выделено несколько записей
    # в инф.панели dpp поменял карточку:  "@template":'yesNoCard.xml',
    if gridContext['@id'] == 'dppLessonGrid':
        selectedIds = sessionjson['related']['gridContext']['selectedRecordId']
        if isinstance(selectedIds, unicode):
            mess = u'Удалить выделенную строку из таблицы?'
        else:
            mess = u'Удалить выделенные строки (%d) из таблицы?' % len(selectedIds)
        xformsdata['schema']['data'] = {'form_text': mess}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardDelDataSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    sessionjson = json.loads(session)["sessioncontext"]
    gridContext = sessionjson["related"]["gridContext"]
    table_name = ''
    grain_name = "umk"
    currentRecordId = gridContext["currentRecordId"]
    # Доп. Атрибуты
    if gridContext["@id"] == "attrGrid" and add == "attrGrid":
        table_name = "dpp_attribute"
        currentAttributeId = gridContext["currentRecordId"]    # приходит ID типа атрибута, выбор uid атрибута
        if "umkVersionId" in context.getData():
            umk_version = context.getData()["umkVersionId"]
        else:
            umk_version = None
        attributeTable = tableCursorImport(grain_name, table_name)(context)
        attributeTable.setRange("umk_version", umk_version)
        attributeTable.setFilter("attribute_id", "%s" % currentAttributeId)
        attributeTable.tryFirst()
        currentRecordId = attributeTable.uid
    # Рабочая группа
    elif gridContext["@id"] == "workGrid" and add == "workGrid":
        table_name = "dpp_work_group"
    # Компетенции
    elif gridContext["@id"] == "competenceGrid" and add == "competenceGrid":
        table_name = "module_competence"
    # УС общие
    elif gridContext["@id"] == "UCgeneralGrid" and add == "UCgeneralGrid":
        currentTable = tableCursorImport(grain_name, "dpp_eus")(context)
        currentTable.get(currentRecordId)
        if "umkVersionId" in context.getData():
            umk_version = context.getData()["umkVersionId"]
        else:
            umk_version = None
        currentTable.setRange('umk_version', umk_version)
        deleteNodeFromHierarchy(context, currentTable, 'dewey', 'sortvalue')

    # УС индивидуальные
    elif gridContext["@id"] == "UCindividualGrid" and add == "UCindividualGrid":
        table_name = "dpp_individual"
    # Расписание ДПП
    elif gridContext["@id"] == "dppLessonGrid" and add == "dppLessonGrid":
        table_name = "dpp_lesson"
    # Расписание ДПП ЕУС
    elif gridContext["@id"] == "dppLessonEusGrid" and add == "dppLessonEusGrid":
        table_name = "dpp_lesson"
    # НСИ компетенции
    elif gridContext["@id"] == "nciCompetenceGrid" and add == "nciCompetenceGrid":
        table_name = "competence"
    # НСИ атрибуты
    elif gridContext["@id"] == "nciAttributeGrid" and add == "nciAttributeGrid":
        table_name = "dpp_attribute_list"
    # НСИ виды занятий
    elif gridContext["@id"] == "nciLessonGrid" and add == "nciLessonGrid":
        table_name = "dpp_lesson_type"
    # НСИ формы контроля
    elif gridContext["@id"] == "nciControlFormGrid" and add == "nciControlFormGrid":
        table_name = "dpp_lesson_type"
    # ЭУС УМК - ЭОР
    elif gridContext["@id"] in ('UCgeneralEorGrid', 'UCindividualEorGrid') and add in ('UCgeneralEorGrid', 'UCindividualEorGrid'):
        table_name = "dpp_element_eor"
    # Версия УМК
    elif gridContext["@id"] == "umkVersionGrid" and add == "umkVersionGrid":
        table_name = "umk_version"
    elif gridContext["@id"] == 'activitiesGrid' and add == 'activitiesGrid':
        table_name = 'dpp_activity'
    # удаление записи
    if table_name:
        currentTable = tableCursorImport(grain_name, table_name)(context)
        currentTable.get(currentRecordId)
# 2015-05-27 Афонин В.В. - для массового удаления, когда в гриде выделено несколько записей
        selectedIds = json.loads(session)["sessioncontext"]["related"]["gridContext"]['selectedRecordId']
        if table_name == "dpp_lesson" and not(isinstance(selectedIds, unicode)):
            for res in selectedIds:
                if currentTable.tryGet(res):
                    currentTable.delete()
        else:
            currentTable.delete()

def cardDelAllDataSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    main = json.loads(main)
    grain_name = main['grain']
    table_name = main['table']
    currentTable = tableCursorImport(grain_name, table_name)(context)
    currentTable.deleteAll()
